package pages

import (
	"fmt"
	"os"

	"github.com/gofiber/fiber/v2"

	"github.com/sethvargo/go-password/password"

	"github.com/containrrr/shoutrrr"

	log "github.com/sirupsen/logrus"
)

// SignupPage is the signup page handler
func SignupPage(c *fiber.Ctx) error {

	username := c.FormValue("username")
	email := c.FormValue("email")
	if username == "" || email == "" {
		log.Error("Username or email is empty", username, email)
		return c.SendStatus(fiber.StatusBadRequest)
	}

	// generate password
	pass, err := password.Generate(30, 10, 10, false, false)
	if err != nil {
		log.Error("Error generating password", err)
		return c.SendStatus(fiber.StatusInternalServerError)
	}

	// create user file
	f, err := os.Create("/var/publapi/users/" + username + ".sh")
	if err != nil {
		log.Error("Error creating user file", err)
		return c.SendStatus(fiber.StatusInternalServerError)
	}
	defer f.Close()

	bashscript := "#!/bin/bash \n" +
		"# Path: /var/publapi/users/" + username + ".sh\n" +
		"# This file is generated by publapi. Do not edit this file.\n" +
		"useradd -Um -s /bin/bash " + username + "\n" +
		"printf \"%s\\n%s\"" + " '" + pass + "' '" + pass + "' | passwd " + username + "\n" +
		"echo " + username + "'s account has been created!"

	fmt.Println(bashscript)

	// write to file
	_, err = f.WriteString(bashscript)
	if err != nil {
		log.Error("Error writing to user file", err)
		return c.SendStatus(fiber.StatusInternalServerError)
	}

	// send notification to admins
	err = shoutrrr.Send(os.Getenv("PUBLAPI_SHOUTRRRURL"), "New user signup! Please review /var/publapi/users/"+username+".sh to approve or deny the user.")
	if err != nil {
		log.Error("Error sending notification to admins", err)
		return c.SendStatus(fiber.StatusInternalServerError)
	}
	return c.JSON(fiber.Map{
		"username": username,
		"message":  "User created! Please allow us 24 hours or more to review your account.",
		"status":   c.Response().StatusCode(),
	})

}
